<?php

namespace App\Exceptions;

use Bsmlight\Exceptions\ValidationException;
use Illuminate\Foundation\Exceptions\Handler as ExceptionHandler;
use Illuminate\Http\JsonResponse;
use Nvmcommunity\Alchemist\RestfulApi\Response\Exceptions\BadRequestException;
use Nvmcommunity\Alchemist\RestfulApi\Response\Exceptions\ForbiddenException;
use Nvmcommunity\Alchemist\RestfulApi\Response\Exceptions\NotFoundException;
use Throwable;

class Handler extends ExceptionHandler
{
    /**
     * A list of the exception types that are not reported.
     *
     * @var array<int, class-string<Throwable>>
     */
    protected $dontReport = [
        //
    ];

    /**
     * A list of the inputs that are never flashed for validation exceptions.
     *
     * @var array<int, string>
     */
    protected $dontFlash = [
        'current_password',
        'password',
        'password_confirmation',
    ];

    /**
     * Register the exception handling callbacks for the application.
     *
     * @return void
     */
    public function register()
    {
        $this->reportable(function (Throwable $e) {
            //
        });
    }

    public function render($request, Throwable $e)
    {
        if ($e instanceof BadRequestException) {
            return response()->json([
                'message' => $e->getMessage()
            ], 400);
        }

        if ($e instanceof ForbiddenException) {
            return response()->json([
                'message' => $e->getMessage()
            ], 403);
        }

        if ($e instanceof NotFoundException) {
            return response()->json([], 404);
        }

        if ($e instanceof ValidationException) {
            return response()->json(json_decode($e->getMessage()), 400);
        }

        return parent::render($request, $e); // TODO: Change the autogenerated stub
    }
}
